Scriptname PO3_RUNEDetectPlayerCasting extends activemagiceffect  

;======================================================================================;
;  PROPERTIES /
;=============/

import PO3_SKSEFunctions

;destruction
Keyword Property MagicDamageFire Auto
Keyword Property MagicDamageFrost Auto
Keyword Property MagicDamageShock Auto
Keyword Property MagicVampireDrain Auto
;alteration
Keyword Property MagicArmorSpell Auto
Keyword Property MagicParalysis Auto
Keyword Property MagicTelekinesis Auto
;restoration
Keyword Property MagicRestoreHealth Auto
Keyword Property MagicTrapPoison Auto
Keyword Property MagicAlchHarmful Auto
Keyword Property MagicTurnUndead Auto
Keyword Property MagicWard Auto
;illusion
Keyword Property MagicInfluenceFrenzy Auto
Keyword Property MagicInfluenceFear Auto
Keyword Property MagicInfluenceCharm Auto
Keyword Property MagicInfluence Auto
Keyword Property MagicInvisibility Auto
;conjuration
Keyword Property MagicSummonFire Auto
Keyword Property MagicSummonFrost Auto
Keyword Property MagicSummonShock Auto
Keyword Property MagicSummonFamiliar Auto
Keyword Property MagicSummonUndead Auto
Keyword Property DLC2MagicAshSpawn Auto
;NONE
Keyword Property DLC1VampireDrainEffect Auto
;
Keyword Property RitualSpellEffect Auto
Keyword Property RitualSpellIllusion Auto
Keyword Property MagicRune Auto

;--------------------------------------------

Actor Property PlayerREF Auto

;-----------------------------------------------

;SPELLS

;destruction
Spell Property po3_RUNE_FireLeftFX Auto
Spell Property po3_RUNE_FireRightFX Auto
Spell Property po3_RUNE_FireConcLeftFX Auto
Spell Property po3_RUNE_FireConcRightFX Auto
;
Spell Property po3_RUNE_FrostLeftFX Auto
Spell Property po3_RUNE_FrostRightFX Auto
Spell Property po3_RUNE_FrostConcLeftFX Auto
Spell Property po3_RUNE_FrostConcRightFX Auto
;
Spell Property po3_RUNE_ShockLeftFX Auto
Spell Property po3_RUNE_ShockRightFX Auto
Spell Property po3_RUNE_ShockConcLeftFX Auto
Spell Property po3_RUNE_ShockConcRightFX Auto
;
Spell Property po3_RUNE_FireRuneLeftFX Auto
Spell Property po3_RUNE_FireRuneRightFX Auto
Spell Property po3_RUNE_FrostRuneLeftFX Auto
Spell Property po3_RUNE_FrostRuneRightFX Auto
Spell Property po3_RUNE_ShockRuneLeftFX Auto
Spell Property po3_RUNE_ShockRuneRightFX Auto
;
Spell Property po3_RUNE_DrainLeftFX Auto
Spell Property po3_RUNE_DrainRightFX Auto
Spell Property po3_RUNE_DrainConcLeftFX Auto
Spell Property po3_RUNE_DrainConcRightFX Auto
;
Spell Property po3_RUNE_AvatarLeftFX Auto
Spell Property po3_RUNE_AvatarRightFX Auto
Spell Property po3_RUNE_AvatarConcLeftFX Auto
Spell Property po3_RUNE_AvatarConcRightFX Auto
;alteration
Spell Property po3_RUNE_ParalyseLeftFX Auto
Spell Property po3_RUNE_ParalyseRightFX Auto
Spell Property po3_RUNE_ParalyseConcLeftFX Auto
Spell Property po3_RUNE_ParalyseConcRightFX Auto
;
Spell Property po3_RUNE_DetectLifeLeftFX Auto
Spell Property po3_RUNE_DetectLifeRightFX Auto
Spell Property po3_RUNE_DetectLifeConcLeftFX Auto
Spell Property po3_RUNE_DetectLifeConcRightFX Auto
;
Spell Property po3_RUNE_LightLeftFX Auto
Spell Property po3_RUNE_LightRightFX Auto
;
Spell Property po3_RUNE_TelekinesisLeftFX Auto
Spell Property po3_RUNE_TelekinesisRightFX Auto
Spell Property po3_RUNE_TelekinesisConcLeftFX Auto
Spell Property po3_RUNE_TelekinesisConcRightFX Auto
;
Spell Property po3_RUNE_AshRuneLeftFX Auto
Spell Property po3_RUNE_AshRuneRightFX Auto
;
Spell Property po3_RUNE_AlterationLeftFX Auto
Spell Property po3_RUNE_AlterationRightFX Auto
Spell Property po3_RUNE_AlterationConcLeftFX Auto
Spell Property po3_RUNE_AlterationConcRightFX Auto
;restoration
Spell Property po3_RUNE_HealLeftFX Auto
Spell Property po3_RUNE_HealRightFX Auto
Spell Property po3_RUNE_HealConcLeftFX Auto
Spell Property po3_RUNE_HealConcRightFX Auto
;
Spell Property po3_RUNE_MysticHealLeftFX Auto
Spell Property po3_RUNE_MysticHealRightFX Auto
Spell Property po3_RUNE_MysticHealConcLeftFX Auto
Spell Property po3_RUNE_MysticHealConcRightFX Auto
;
Spell Property po3_RUNE_ArmourLeftFX Auto
Spell Property po3_RUNE_ArmourRightFX Auto
Spell Property po3_RUNE_ArmourConcLeftFX Auto
Spell Property po3_RUNE_ArmourConcRightFX Auto
;
Spell Property po3_RUNE_PoisonLeftFX Auto
Spell Property po3_RUNE_PoisonRightFX Auto
Spell Property po3_RUNE_PoisonConcLeftFX Auto
Spell Property po3_RUNE_PoisonConcRightFX Auto
;
Spell Property po3_RUNE_PoisonRuneLeftFX Auto
Spell Property po3_RUNE_PoisonRuneRightFX Auto
;
Spell Property po3_RUNE_SunLeftFX Auto
Spell Property po3_RUNE_SunRightFX Auto
Spell Property po3_RUNE_SunConcLeftFX Auto
Spell Property po3_RUNE_SunConcRightFX Auto
;
Spell Property po3_RUNE_WardFX Auto
;illusion
Spell Property po3_RUNE_FrenzyLeftFX Auto
Spell Property po3_RUNE_FrenzyRightFX Auto
Spell Property po3_RUNE_FrenzyConcLeftFX Auto
Spell Property po3_RUNE_FrenzyConcRightFX Auto
;
Spell Property po3_RUNE_FrenzyRuneLeftFX Auto
Spell Property po3_RUNE_FrenzyRuneRightFX Auto
;
Spell Property po3_RUNE_CalmLeftFX Auto
Spell Property po3_RUNE_CalmRightFX Auto
Spell Property po3_RUNE_CalmConcLeftFX Auto
Spell Property po3_RUNE_CalmConcRightFX Auto
;
Spell Property po3_RUNE_InvisibilityLeftFX Auto
Spell Property po3_RUNE_InvisibilityRightFX Auto
Spell Property po3_RUNE_InvisibilityConcLeftFX Auto
Spell Property po3_RUNE_InvisibilityConcRightFX Auto
;
Spell Property po3_RUNE_IllusionLeftFX Auto
Spell Property po3_RUNE_IllusionRightFX Auto
Spell Property po3_RUNE_IllusionConcLeftFX Auto
Spell Property po3_RUNE_IllusionConcRightFX Auto
;conjuration
Spell Property po3_RUNE_ConjureFireLeftFX Auto
Spell Property po3_RUNE_ConjureFireRightFX Auto
;
Spell Property po3_RUNE_ConjureFrostLeftFX Auto
Spell Property po3_RUNE_ConjureFrostRightFX Auto
;
Spell Property po3_RUNE_ConjureShockLeftFX Auto
Spell Property po3_RUNE_ConjureShockRightFX Auto
;
Spell Property po3_RUNE_ConjureFamiliarLeftFX Auto
Spell Property po3_RUNE_ConjureFamiliarRightFX Auto
;
Spell Property po3_RUNE_ConjurationLeftFX Auto
Spell Property po3_RUNE_ConjurationRightFX Auto
Spell Property po3_RUNE_ConjurationConcLeftFX Auto
Spell Property po3_RUNE_ConjurationConcRightFX Auto
;
Spell Property po3_RUNE_ReanimateLeftFX Auto
Spell Property po3_RUNE_ReanimateRightFX Auto
Spell Property po3_RUNE_ReanimateConcLeftFX Auto
Spell Property po3_RUNE_ReanimateConcRightFX Auto
;
Spell Property po3_RUNE_SoulTrapLeftFX Auto
Spell Property po3_RUNE_SoulTrapRightFX Auto
;
Spell Property po3_RUNE_BanishLeftFX Auto
Spell Property po3_RUNE_BanishRightFX Auto

;RITUAL SPELLS

;destruction
Spell Property po3_RUNE_FireRitualFX Auto
;
Spell Property po3_RUNE_FrostRitualFX Auto
;
Spell Property po3_RUNE_ShockRitualFX Auto
;
Spell Property po3_RUNE_DrainRitualFX Auto
;
Spell Property po3_RUNE_AvatarRitualFX Auto
;alteration
Spell Property po3_RUNE_ParalyseRitualFX Auto
;
Spell Property po3_RUNE_DetectLifeRitualFX Auto
;
Spell Property po3_RUNE_TelekinesisRitualFX Auto
;
Spell Property po3_RUNE_AlterationRitualFX Auto
;restoration
Spell Property po3_RUNE_HealRitualFX Auto
;
Spell Property po3_RUNE_MysticHealRitualFX Auto
;
Spell Property po3_RUNE_ArmourRitualFX Auto
;
Spell Property po3_RUNE_PoisonRitualFX Auto
;
Spell Property po3_RUNE_SunRitualFX Auto
;illusion
Spell Property po3_RUNE_FrenzyRitualFX Auto
;
Spell Property po3_RUNE_CalmRitualFX Auto
;
Spell Property po3_RUNE_IllusionRitualFX Auto
;conjuration
Spell Property po3_RUNE_ConjureFireRitualFX Auto
Spell Property po3_RUNE_ConjureFrostRitualFX Auto
Spell Property po3_RUNE_ConjureShockRitualFX Auto
Spell Property po3_RUNE_ConjureFamiliarRitualFX Auto
;
Spell Property po3_RUNE_ConjurationRitualFX Auto
;
Spell Property po3_RUNE_ReanimateRitualFX Auto
;
Spell Property po3_RUNE_SoulTrapRitualFX Auto

;----------------------------------------------

Spell LeftSpell
Spell RightSpell
Spell LeftFXSpell
Spell RightFXSpell
Spell LeftWard 
Spell RightWard 

Spell Property DLC2PoisonRune Auto

Scroll LeftScroll
Scroll RightScroll

;------------------------------------------------

MagicEffect Property RestoreHealthFFActor Auto
MagicEffect Property SoulTrapFFActor Auto
MagicEffect Property DLC1SunLightFFSelf Auto
MagicEffect Property DLC1SunDamageFFAimed Auto
MagicEffect Property InfluenceAggDownFFAimed Auto
MagicEffect Property InfluenceAggUpFFAimed Auto
MagicEffect Property DetectLifeFriendInteriorSelfFF Auto
MagicEffect Property LightFFSelf Auto
MagicEffect Property DLC1EnchSunDamage Auto
MagicEffect Property po3_RUNE_MysticHealDummyEffect Auto

;-----------------------------------------------------------

Art Heal01HandEffects
Art SoulTrapHandEffects 
Art DLC1_SunCloakSpellHandFX
Art IllusionPosFXHand01
Art IllusionNegFXHand01
Art DetectLifeFXHand01
Art FXLightSpellHandEffects
Art HealsMystFXHand01 

;-------------------------------------------------------------

int RightSpellType = 0
int LeftSpellType = 0 

;------------------------------------------------------------

EffectShader Property DLC1SunFireImpactFXShader Auto
EffectShader Property DLC1SunFireFXShader Auto

;-----------------------------------------------------------------

GlobalVariable Property po3_RUNE_AllowPCFFSpells Auto
GlobalVariable Property po3_RUNE_AllowPCSelfSpells Auto
GlobalVariable Property po3_RUNE_AllowPCConcSpells Auto
GlobalVariable Property po3_RUNE_AllowMagAnimPatch Auto
GlobalVariable Property po3_RUNE_AllowPCScrolls Auto
GlobalVariable Property po3_RUNE_AllowMasterSpells Auto

;------------------------------------------------------------

Light Property MagicLightFrostHand01 Auto
Light Property MagicLightFireInHand Auto
Light Property MagicLightShockInHand Auto
Light Property MagicLightTelekinesisHand01 Auto 

;----------------------------------------------------------------

bool DoOnce = false

;======================================================================================;
;  EVENTS  /
;=============/

;------------------ EVENT ONEFFECTSTART() ---------------------------------------- 

Event OnEffectStart(Actor akTarget, Actor akCaster)

	RegisterForAnimationEvent(PlayerRef, "BeginCastRight")
	RegisterForAnimationEvent(PlayerRef, "BeginCastLeft")
	RegisterForAnimationEvent(PlayerRef, "MRh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "MLh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "CastStop")
	RegisterForAnimationEvent(PlayerRef, "weaponSheathe")

	;------------------VARIABLES----------------------------	
	Heal01HandEffects = RestoreHealthFFActor.GetCastingArt()
	HealsMystFXHand01 = po3_RUNE_MysticHealDummyEffect.GetCastingArt()
	SoulTrapHandEffects = SoulTrapFFActor.GetCastingArt()
	DLC1_SunCloakSpellHandFX = DLC1SunLightFFSelf.GetCastingArt()
	IllusionPosFXHand01 = InfluenceAggDownFFAimed.GetCastingArt()
	DetectLifeFXHand01 = DetectLifeFriendInteriorSelfFF.GetCastingArt()
	FXLightSpellHandEffects = LightFFSelf.GetCastingArt()
	IllusionNegFXHand01 = InfluenceAggUpFFAimed.GetCastingArt()	
	;-----------------------------------------------------------
				
EndEvent

;-----------------------------------------------------------------------------------

Event OnPlayerLoadGame()

	RegisterForAnimationEvent(PlayerRef, "BeginCastRight")
	RegisterForAnimationEvent(PlayerRef, "BeginCastLeft")
	RegisterForAnimationEvent(PlayerRef, "MRh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "MLh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "CastStop")
	RegisterForAnimationEvent(PlayerRef, "weaponSheathe")

	;------------------VARIABLES----------------------------	
	Heal01HandEffects = RestoreHealthFFActor.GetCastingArt()
	HealsMystFXHand01 = po3_RUNE_MysticHealDummyEffect.GetCastingArt()
	SoulTrapHandEffects = SoulTrapFFActor.GetCastingArt()
	DLC1_SunCloakSpellHandFX = DLC1SunLightFFSelf.GetCastingArt()
	IllusionPosFXHand01 = InfluenceAggDownFFAimed.GetCastingArt()
	DetectLifeFXHand01 = DetectLifeFriendInteriorSelfFF.GetCastingArt()
	FXLightSpellHandEffects = LightFFSelf.GetCastingArt()
	IllusionNegFXHand01 = InfluenceAggUpFFAimed.GetCastingArt()	
	;-----------------------------------------------------------
	
EndEvent

;------------------ EVENT ONRACESWITCHCOMPLETE() ----------------------------------

Event OnRaceSwitchComplete()

	Utility.Wait(1.0)	
	
	RegisterForAnimationEvent(PlayerRef, "BeginCastRight")
	RegisterForAnimationEvent(PlayerRef, "BeginCastLeft")
	RegisterForAnimationEvent(PlayerRef, "MRh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "MLh_SpellFire_Event") 
	RegisterForAnimationEvent(PlayerRef, "CastStop")
	RegisterForAnimationEvent(PlayerRef, "weaponSheathe")
		
EndEvent

;------------------ EVENT ONANIMATIONEVENT() ---------------------------------------- 

Event OnAnimationEvent(ObjectReference akSource, string asEventName)

	If akSource == PlayerRef 
		;-------------------------------------------------------------------------
		If  asEventName == "BeginCastLeft" ; casting left	
			Form LeftMagicCast = PlayerRef.GetEquippedObject(0) 
			If (LeftMagicCast as Spell)
				LeftSpell = (LeftMagicCast as Spell)
				If (LeftSpell.HasKeyword(RitualSpellEffect) || LeftSpell.HasKeyword(RitualSpellIllusion)) && po3_RUNE_AllowMasterSpells.GetValue() == 1.0 
					LeftSpellType = GetTypeOfRitualRune(LeftSpell)	
					;destruction		;(1-7)
					If LeftSpellType == 1
						PlayerRef.AddSpell(po3_RUNE_FireRitualFX, false)
						LeftFXSpell = po3_RUNE_FireRitualFX
					elseif LeftSpellType == 2
						PlayerRef.AddSpell(po3_RUNE_FrostRitualFX, false)
						LeftFXSpell = po3_RUNE_FrostRitualFX
					elseif LeftSpellType == 3
						PlayerRef.AddSpell(po3_RUNE_ShockRitualFX, false)
						LeftFXSpell = po3_RUNE_ShockRitualFX
					elseif LeftSpellType == 4
						PlayerRef.AddSpell(po3_RUNE_DrainRitualFX, false)
						LeftFXSpell = po3_RUNE_DrainRitualFX
					;restoration		;(8-11, 16)	
					elseif LeftSpellType == 8
						PlayerRef.AddSpell(po3_RUNE_SunRitualFX, false)
						LeftFXSpell = po3_RUNE_SunRitualFX
					elseif LeftSpellType == 9
						PlayerRef.AddSpell(po3_RUNE_HealRitualFX, false)
						LeftFXSpell = po3_RUNE_HealRitualFX
					elseif LeftSpellType == 11
						PlayerRef.AddSpell(po3_RUNE_PoisonRitualFX, false)
						LeftFXSpell = po3_RUNE_PoisonRitualFX
					;alteration		;(12-17, 4)
					elseif LeftSpellType == 13
						PlayerRef.AddSpell(po3_RUNE_ParalyseRitualFX, false)
						LeftFXSpell = po3_RUNE_ParalyseRitualFX
					elseif LeftSpellType == 14
						PlayerRef.AddSpell(po3_RUNE_ArmourRitualFX, false)
						LeftFXSpell = po3_RUNE_ArmourRitualFX
					elseif LeftSpellType == 15
						PlayerRef.AddSpell(po3_RUNE_DetectLifeRitualFX, false)
						LeftFXSpell = po3_RUNE_DetectLifeRitualFX
					elseif LeftSpellType == 17
						PlayerRef.AddSpell(po3_RUNE_TelekinesisRitualFX, false)
						LeftFXSpell = po3_RUNE_TelekinesisRitualFX
					elseif LeftSpellType == 18		
						PlayerRef.AddSpell(po3_RUNE_AlterationRitualFX, false)
						LeftFXSpell = po3_RUNE_AlterationRitualFX
					;illusion		;(18-22)
					elseif LeftSpellType == 20		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRitualFX, false)
						LeftFXSpell = po3_RUNE_FrenzyRitualFX
					elseif LeftSpellType == 21
						PlayerRef.AddSpell(po3_RUNE_CalmRitualFX, false)
						LeftFXSpell = po3_RUNE_CalmRitualFX
					elseif LeftSpellType == 23
						PlayerRef.AddSpell(po3_RUNE_IllusionRitualFX, false)
						LeftFXSpell = po3_RUNE_IllusionRitualFX	
					;conjuration	;(23-28)
					elseif LeftSpellType == 24
						PlayerRef.AddSpell(po3_RUNE_ConjureFireRitualFX, false)
						LeftFXSpell = po3_RUNE_ConjureFireRitualFX
					elseif LeftSpellType == 25
						PlayerRef.AddSpell(po3_RUNE_ConjureFrostRitualFX, false)
						LeftFXSpell = po3_RUNE_ConjureFrostRitualFX
					elseif LeftSpellType == 26
						PlayerRef.AddSpell(po3_RUNE_ConjureShockRitualFX, false)
						LeftFXSpell = po3_RUNE_ConjureShockRitualFX	
					elseif LeftSpellType == 27
						PlayerRef.AddSpell(po3_RUNE_ConjureFamiliarRitualFX, false)
						LeftFXSpell = po3_RUNE_ConjureFamiliarRitualFX
					elseif LeftSpellType == 28
						PlayerRef.AddSpell(po3_RUNE_ReanimateRitualFX, false)
						LeftFXSpell = po3_RUNE_ReanimateRitualFX				
					elseif LeftSpellType == 29
						PlayerRef.AddSpell(po3_RUNE_SoulTrapRitualFX, false)
						LeftFXSpell = po3_RUNE_SoulTrapRitualFX
					elseif LeftSpellType == 30
						PlayerRef.AddSpell(po3_RUNE_ConjurationRitualFX, false)
						LeftFXSpell = po3_RUNE_ConjurationRitualFX
					elseif LeftSpellType == 31
						PlayerRef.AddSpell(po3_RUNE_MysticHealRitualFX, false)
						LeftFXSpell = po3_RUNE_MysticHealRitualFX
					elseif LeftSpellType == 32
						PlayerRef.AddSpell(po3_RUNE_AvatarRitualFX, false)
						LeftFXSpell = po3_RUNE_AvatarRitualFX
					endif
				elseif CanCastSpellType(LeftSpell) 
					LeftSpellType = GetTypeOfRune(LeftSpell)	
					;destruction		;(1-7)
					If LeftSpellType == 1
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_FireLeftFX, po3_RUNE_FireConcLeftFX)
					elseif LeftSpellType == 2
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_FrostLeftFX, po3_RUNE_FrostConcLeftFX)
					elseif LeftSpellType == 3
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ShockLeftFX, po3_RUNE_ShockConcLeftFX)
					elseif LeftSpellType == 4
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_DrainLeftFX, po3_RUNE_DrainConcLeftFX)
					elseif LeftSpellType == 5
						PlayerRef.AddSpell(po3_RUNE_FireRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FireRuneLeftFX
					elseif LeftSpellType == 6
						PlayerRef.AddSpell(po3_RUNE_FrostRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FrostRuneLeftFX
					elseif LeftSpellType == 7
						PlayerRef.AddSpell(po3_RUNE_ShockRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_ShockRuneLeftFX
					;restoration		;(8-11, 16)	
					elseif LeftSpellType == 8
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_SunLeftFX, po3_RUNE_SunConcLeftFX)
					elseif LeftSpellType == 9
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_HealLeftFX, po3_RUNE_HealConcLeftFX)
					elseif LeftSpellType == 10
						PlayerRef.AddSpell(po3_RUNE_PoisonRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_PoisonRuneLeftFX
					elseif LeftSpellType == 11
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_PoisonLeftFX, po3_RUNE_PoisonConcLeftFX)
					;alteration		;(12-17, 4)
					elseif LeftSpellType == 12
						PlayerRef.AddSpell(po3_RUNE_AshRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_AshRuneLeftFX
					elseif LeftSpellType == 13
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ParalyseLeftFX, po3_RUNE_ParalyseConcLeftFX)
					elseif LeftSpellType == 14
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ArmourLeftFX, po3_RUNE_ArmourConcLeftFX)
					elseif LeftSpellType == 15
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_DetectLifeLeftFX, po3_RUNE_DetectLifeConcLeftFX)
					elseif LeftSpellType == 16
						PlayerRef.AddSpell(po3_RUNE_LightLeftFX, false)
						LeftFXSpell = po3_RUNE_LightLeftFX
					elseif LeftSpellType == 17
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_TelekinesisLeftFX, po3_RUNE_TelekinesisConcLeftFX)
					elseif LeftSpellType == 18		
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_AlterationLeftFX, po3_RUNE_AlterationConcLeftFX)
					;illusion		;(18-22)
					elseif LeftSpellType == 19		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FrenzyRuneLeftFX
					elseif LeftSpellType == 20		
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_FrenzyLeftFX, po3_RUNE_FrenzyConcLeftFX)
					elseif LeftSpellType == 21
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_CalmLeftFX, po3_RUNE_CalmConcLeftFX)	
					elseif LeftSpellType == 22
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_InvisibilityLeftFX, po3_RUNE_InvisibilityConcLeftFX)
					elseif LeftSpellType == 23
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_IllusionLeftFX, po3_RUNE_IllusionConcLeftFX)	
					;conjuration	;(23-28)
					elseif LeftSpellType == 24
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ConjureFireLeftFX, po3_RUNE_ConjureFireLeftFX)
					elseif LeftSpellType == 25
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ConjureFrostLeftFX, po3_RUNE_ConjureFrostLeftFX)
					elseif LeftSpellType == 26
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ConjureShockLeftFX, po3_RUNE_ConjureShockLeftFX)
					elseif LeftSpellType == 27
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ConjureFamiliarLeftFX, po3_RUNE_ConjureFamiliarLeftFX)
					elseif LeftSpellType == 28
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ReanimateLeftFX, po3_RUNE_ReanimateConcLeftFX)				
					elseif LeftSpellType == 29
						PlayerRef.AddSpell(po3_RUNE_SoulTrapLeftFX, false)
						LeftFXSpell = po3_RUNE_SoulTrapLeftFX
					elseif LeftSpellType == 30
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_ConjurationLeftFX, po3_RUNE_ConjurationConcLeftFX)
					elseif LeftSpellType == 31
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_MysticHealLeftFX, po3_RUNE_MysticHealConcLeftFX)
					elseif LeftSpellType == 32
						LeftFXSpell = MagicCircle(LeftSpell, po3_RUNE_AvatarLeftFX, po3_RUNE_AvatarConcLeftFX)
					elseif LeftSpellType == 33
						PlayerRef.AddSpell(po3_RUNE_WardFX, false)
						LeftFXSpell = po3_RUNE_WardFX
						LeftWard = LeftSpell
					elseif LeftSpellType == 34
						PlayerRef.AddSpell(po3_RUNE_BanishLeftFX, false)
						LeftFXSpell = po3_RUNE_BanishLeftFX
					endif
				endif
			elseif (LeftMagicCast as Scroll)
				LeftScroll = (LeftMagicCast as Scroll)
				If CanCastScrollType(LeftScroll) 
					LeftSpellType = GetTypeOfRuneScroll(LeftScroll)	
					;destruction		;(1-7)
					If LeftSpellType == 1
						PlayerRef.AddSpell(po3_RUNE_FireLeftFX, false)
						LeftFXSpell = po3_RUNE_FireLeftFX
					elseif LeftSpellType == 2
						PlayerRef.AddSpell(po3_RUNE_FrostLeftFX, false)
						LeftFXSpell = po3_RUNE_FrostLeftFX
					elseif LeftSpellType == 3
						PlayerRef.AddSpell(po3_RUNE_ShockLeftFX, false)
						LeftFXSpell = po3_RUNE_ShockLeftFX
					elseif LeftSpellType == 4
						PlayerRef.AddSpell(po3_RUNE_DrainLeftFX, false)
						LeftFXSpell = po3_RUNE_DrainLeftFX
					elseif LeftSpellType == 5
						PlayerRef.AddSpell(po3_RUNE_FireRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FireRuneLeftFX
					elseif LeftSpellType == 6
						PlayerRef.AddSpell(po3_RUNE_FrostRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FrostRuneLeftFX
					elseif LeftSpellType == 7
						PlayerRef.AddSpell(po3_RUNE_ShockRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_ShockRuneLeftFX
					;restoration		;(8-11, 16)	
					elseif LeftSpellType == 8
						PlayerRef.AddSpell(po3_RUNE_SunLeftFX, false)
						LeftFXSpell = po3_RUNE_SunLeftFX
					elseif LeftSpellType == 9
						PlayerRef.AddSpell(po3_RUNE_HealLeftFX, false)
						LeftFXSpell = po3_RUNE_HealLeftFX
					elseif LeftSpellType == 10
						PlayerRef.AddSpell(po3_RUNE_PoisonRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_PoisonRuneLeftFX
					elseif LeftSpellType == 11
						PlayerRef.AddSpell(po3_RUNE_PoisonLeftFX, false)
						LeftFXSpell = po3_RUNE_PoisonLeftFX
					;alteration		;(12-17, 4)
					elseif LeftSpellType == 12
						PlayerRef.AddSpell(po3_RUNE_AshRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_AshRuneLeftFX
					elseif LeftSpellType == 13
						PlayerRef.AddSpell(po3_RUNE_ParalyseLeftFX, false)
						LeftFXSpell = po3_RUNE_ParalyseLeftFX
					elseif LeftSpellType == 14
						PlayerRef.AddSpell(po3_RUNE_ArmourLeftFX, false)
						LeftFXSpell = po3_RUNE_ArmourLeftFX
					elseif LeftSpellType == 15
						PlayerRef.AddSpell(po3_RUNE_DetectLifeLeftFX, false)
						LeftFXSpell = po3_RUNE_DetectLifeLeftFX
					elseif LeftSpellType == 16
						PlayerRef.AddSpell(po3_RUNE_LightLeftFX, false)
						LeftFXSpell = po3_RUNE_LightLeftFX
					elseif LeftSpellType == 17
						PlayerRef.AddSpell(po3_RUNE_TelekinesisLeftFX, false)
						LeftFXSpell = po3_RUNE_TelekinesisLeftFX
					elseif LeftSpellType == 18		
						PlayerRef.AddSpell(po3_RUNE_AlterationLeftFX, false)
						LeftFXSpell = po3_RUNE_AlterationLeftFX
					;illusion		;(18-22)
					elseif LeftSpellType == 19		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRuneLeftFX, false)
						LeftFXSpell = po3_RUNE_FrenzyRuneLeftFX
					elseif LeftSpellType == 20		
						PlayerRef.AddSpell(po3_RUNE_FrenzyLeftFX, false)
						LeftFXSpell = po3_RUNE_FrenzyLeftFX
					elseif LeftSpellType == 21
						PlayerRef.AddSpell(po3_RUNE_CalmLeftFX, false)
						LeftFXSpell = po3_RUNE_CalmLeftFX
					elseif LeftSpellType == 22
						PlayerRef.AddSpell(po3_RUNE_InvisibilityLeftFX, false)
						LeftFXSpell = po3_RUNE_InvisibilityLeftFX
					elseif LeftSpellType == 23
						PlayerRef.AddSpell(po3_RUNE_IllusionLeftFX, false)
						LeftFXSpell = po3_RUNE_IllusionLeftFX	
					;conjuration	;(23-28)
					elseif LeftSpellType == 24
						PlayerRef.AddSpell(po3_RUNE_ConjureFireLeftFX, false)
						LeftFXSpell = po3_RUNE_ConjureFireLeftFX
					elseif LeftSpellType == 25
						PlayerRef.AddSpell(po3_RUNE_ConjureFrostLeftFX, false)
						LeftFXSpell = po3_RUNE_ConjureFrostLeftFX
					elseif LeftSpellType == 26
						PlayerRef.AddSpell(po3_RUNE_ConjureShockLeftFX, false)
						LeftFXSpell = po3_RUNE_ConjureShockLeftFX	
					elseif LeftSpellType == 27
						PlayerRef.AddSpell(po3_RUNE_ConjureFamiliarLeftFX, false)
						LeftFXSpell = po3_RUNE_ConjureFamiliarLeftFX
					elseif LeftSpellType == 28
						PlayerRef.AddSpell(po3_RUNE_ReanimateLeftFX, false)
						LeftFXSpell = po3_RUNE_ReanimateLeftFX				
					elseif LeftSpellType == 29
						PlayerRef.AddSpell(po3_RUNE_SoulTrapLeftFX, false)
						LeftFXSpell = po3_RUNE_SoulTrapLeftFX
					elseif LeftSpellType == 30
						PlayerRef.AddSpell(po3_RUNE_ConjurationLeftFX, false)
						LeftFXSpell = po3_RUNE_ConjurationLeftFX
					elseif LeftSpellType == 31
						PlayerRef.AddSpell(po3_RUNE_MysticHealLeftFX, false)
						LeftFXSpell = po3_RUNE_MysticHealLeftFX
					elseif LeftSpellType == 32
						PlayerRef.AddSpell(po3_RUNE_AvatarLeftFX, false)
						LeftFXSpell = po3_RUNE_AvatarLeftFX
					elseif LeftSpellType == 34
						PlayerRef.AddSpell(po3_RUNE_BanishLeftFX, false)
						LeftFXSpell = po3_RUNE_BanishLeftFX
					endif
				endif
			endif
		endif
		;-----------------------------------------------------------------------
		If asEventName == "BeginCastRight" ; casting right	
			Form RightMagicCast = PlayerRef.GetEquippedObject(1) 
			If (RightMagicCast as Spell)
				RightSpell = (RightMagicCast as Spell)	
				If CanCastSpellType(RightSpell) 	
					RightSpellType = GetTypeOfRune(RightSpell)	
					;destruction		;(1-7)
					If RightSpellType == 1
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_FireRightFX, po3_RUNE_FireConcRightFX )
					elseif RightSpellType == 2
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_FrostRightFX, po3_RUNE_FrostConcRightFX )
					elseif RightSpellType == 3
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_ShockRightFX, po3_RUNE_ShockConcRightFX )
					elseif RightSpellType == 4
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_DrainRightFX, po3_RUNE_DrainConcRightFX )
					elseif RightSpellType == 5
						PlayerRef.AddSpell(po3_RUNE_FireRuneRightFX, false)
						RightFXSpell = po3_RUNE_FireRuneRightFX
					elseif RightSpellType == 6
						PlayerRef.AddSpell(po3_RUNE_FrostRuneRightFX, false)
						RightFXSpell = po3_RUNE_FrostRuneRightFX
					elseif RightSpellType == 7
						PlayerRef.AddSpell(po3_RUNE_ShockRuneRightFX, false)
						RightFXSpell = po3_RUNE_ShockRuneRightFX
					;restoration		;(8-11, 16)	
					elseif RightSpellType == 8
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_SunRightFX, po3_RUNE_SunConcRightFX)
					elseif RightSpellType == 9
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_HealRightFX, po3_RUNE_HealConcRightFX)
					elseif RightSpellType == 10
						PlayerRef.AddSpell(po3_RUNE_PoisonRuneRightFX, false)
						RightFXSpell = po3_RUNE_PoisonRuneRightFX
					elseif RightSpellType == 11
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_PoisonRightFX, po3_RUNE_PoisonConcRightFX)
					;alteration		;(12-17, 4)
					elseif RightSpellType == 12
						PlayerRef.AddSpell(po3_RUNE_AshRuneRightFX, false)
						RightFXSpell = po3_RUNE_AshRuneRightFX
					elseif RightSpellType == 13
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_ParalyseRightFX, po3_RUNE_ParalyseConcRightFX)
					elseif RightSpellType == 14
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_ArmourRightFX, po3_RUNE_ArmourConcRightFX)
					elseif RightSpellType == 15
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_DetectLifeRightFX, po3_RUNE_DetectLifeConcRightFX)
					elseif RightSpellType == 16
						PlayerRef.AddSpell(po3_RUNE_LightRightFX, false)
						RightFXSpell = po3_RUNE_LightRightFX
					elseif RightSpellType == 17
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_TelekinesisRightFX, po3_RUNE_TelekinesisConcRightFX)
					elseif RightSpellType == 18		
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_AlterationRightFX, po3_RUNE_AlterationConcRightFX)
					;illusion		;(18-22)
					elseif RightSpellType == 19		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRuneRightFX, false)
						RightFXSpell = po3_RUNE_FrenzyRuneRightFX
					elseif RightSpellType == 20		
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_FrenzyRightFX, po3_RUNE_FrenzyConcRightFX)
					elseif RightSpellType == 21
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_CalmRightFX, po3_RUNE_CalmConcRightFX)	
					elseif RightSpellType == 22
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_InvisibilityRightFX, po3_RUNE_InvisibilityConcRightFX)
					elseif RightSpellType == 23
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_IllusionRightFX, po3_RUNE_IllusionConcRightFX)	
					;conjuration	;(23-28)
					elseif RightSpellType == 24
						PlayerRef.AddSpell(po3_RUNE_ConjureFireRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFireRightFX
					elseif RightSpellType == 25
						PlayerRef.AddSpell(po3_RUNE_ConjureFrostRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFrostRightFX
					elseif RightSpellType == 26
						PlayerRef.AddSpell(po3_RUNE_ConjureShockRightFX, false)
						RightFXSpell = po3_RUNE_ConjureShockRightFX	
					elseif RightSpellType == 27
						PlayerRef.AddSpell(po3_RUNE_ConjureFamiliarRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFamiliarRightFX
					elseif RightSpellType == 28
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_ReanimateRightFX, po3_RUNE_ReanimateConcRightFX)				
					elseif RightSpellType == 29
						PlayerRef.AddSpell(po3_RUNE_SoulTrapRightFX, false)
						RightFXSpell = po3_RUNE_SoulTrapRightFX
					elseif RightSpellType == 30
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_ConjurationRightFX, po3_RUNE_ConjurationConcRightFX)
					elseif RightSpellType == 31
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_MysticHealRightFX, po3_RUNE_MysticHealConcRightFX)
					elseif RightSpellType == 32
						RightFXSpell = MagicCircle(RightSpell, po3_RUNE_AvatarRightFX, po3_RUNE_AvatarConcRightFX)
					elseif RightSpellType == 33
						PlayerRef.AddSpell(po3_RUNE_WardFX, false)
						RightFXSpell = po3_RUNE_WardFX
						RightWard = RightSpell
					elseif RightSpellType == 34
						PlayerRef.AddSpell(po3_RUNE_BanishRightFX, false)
						RightFXSpell = po3_RUNE_BanishRightFX
					endif
				endif
			elseif (RightMagicCast as Scroll)
				RightScroll = (RightMagicCast as Scroll)	
				If CanCastScrollType(RightScroll) 
					RightSpellType = GetTypeOfRuneScroll(RightScroll)	
					;destruction		;(1-7)
					If RightSpellType == 1
						PlayerRef.AddSpell(po3_RUNE_FireRightFX, false)
						RightFXSpell = po3_RUNE_FireRightFX
					elseif RightSpellType == 2
						PlayerRef.AddSpell(po3_RUNE_FrostRightFX, false)
						RightFXSpell = po3_RUNE_FrostRightFX
					elseif RightSpellType == 3
						PlayerRef.AddSpell(po3_RUNE_ShockRightFX, false)
						RightFXSpell = po3_RUNE_ShockRightFX
					elseif RightSpellType == 4
						PlayerRef.AddSpell(po3_RUNE_DrainRightFX, false)
						RightFXSpell = po3_RUNE_DrainRightFX
					elseif RightSpellType == 5
						PlayerRef.AddSpell(po3_RUNE_FireRuneRightFX, false)
						RightFXSpell = po3_RUNE_FireRuneRightFX
					elseif RightSpellType == 6
						PlayerRef.AddSpell(po3_RUNE_FrostRuneRightFX, false)
						RightFXSpell = po3_RUNE_FrostRuneRightFX
					elseif RightSpellType == 7
						PlayerRef.AddSpell(po3_RUNE_ShockRuneRightFX, false)
						RightFXSpell = po3_RUNE_ShockRuneRightFX
					;restoration		;(8-11, 16)	
					elseif RightSpellType == 8
						PlayerRef.AddSpell(po3_RUNE_SunRightFX, false)
						RightFXSpell = po3_RUNE_SunRightFX
					elseif RightSpellType == 9
						PlayerRef.AddSpell(po3_RUNE_HealRightFX, false)
						RightFXSpell = po3_RUNE_HealRightFX
					elseif RightSpellType == 10
						PlayerRef.AddSpell(po3_RUNE_PoisonRuneRightFX, false)
						RightFXSpell = po3_RUNE_PoisonRuneRightFX
					elseif RightSpellType == 11
						PlayerRef.AddSpell(po3_RUNE_PoisonRightFX, false)
						RightFXSpell = po3_RUNE_PoisonRightFX
					;alteration		;(12-17, 4)
					elseif RightSpellType == 12
						PlayerRef.AddSpell(po3_RUNE_AshRuneRightFX, false)
						RightFXSpell = po3_RUNE_AshRuneRightFX
					elseif RightSpellType == 13
						PlayerRef.AddSpell(po3_RUNE_ParalyseRightFX, false)
						RightFXSpell = po3_RUNE_ParalyseRightFX
					elseif RightSpellType == 14
						PlayerRef.AddSpell(po3_RUNE_ArmourRightFX, false)
						RightFXSpell = po3_RUNE_ArmourRightFX
					elseif RightSpellType == 15
						PlayerRef.AddSpell(po3_RUNE_DetectLifeRightFX, false)
						RightFXSpell = po3_RUNE_DetectLifeRightFX
					elseif RightSpellType == 16
						PlayerRef.AddSpell(po3_RUNE_LightRightFX, false)
						RightFXSpell = po3_RUNE_LightRightFX
					elseif RightSpellType == 17
						PlayerRef.AddSpell(po3_RUNE_TelekinesisRightFX, false)
						RightFXSpell = po3_RUNE_TelekinesisRightFX
					elseif RightSpellType == 18		
						PlayerRef.AddSpell(po3_RUNE_AlterationRightFX, false)
						RightFXSpell = po3_RUNE_AlterationRightFX
					;illusion		;(18-22)
					elseif RightSpellType == 19		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRuneRightFX, false)
						RightFXSpell = po3_RUNE_FrenzyRuneRightFX
					elseif RightSpellType == 20		
						PlayerRef.AddSpell(po3_RUNE_FrenzyRightFX, false)
						RightFXSpell = po3_RUNE_FrenzyRightFX
					elseif RightSpellType == 21
						PlayerRef.AddSpell(po3_RUNE_CalmRightFX, false)
						RightFXSpell = po3_RUNE_CalmRightFX
					elseif RightSpellType == 22
						PlayerRef.AddSpell(po3_RUNE_InvisibilityRightFX, false)
						RightFXSpell = po3_RUNE_InvisibilityRightFX
					elseif RightSpellType == 23
						PlayerRef.AddSpell(po3_RUNE_IllusionRightFX, false)
						RightFXSpell = po3_RUNE_IllusionRightFX	
					;conjuration	;(23-28)
					elseif RightSpellType == 24
						PlayerRef.AddSpell(po3_RUNE_ConjureFireRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFireRightFX
					elseif RightSpellType == 25
						PlayerRef.AddSpell(po3_RUNE_ConjureFrostRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFrostRightFX
					elseif RightSpellType == 26
						PlayerRef.AddSpell(po3_RUNE_ConjureShockRightFX, false)
						RightFXSpell = po3_RUNE_ConjureShockRightFX	
					elseif RightSpellType == 27
						PlayerRef.AddSpell(po3_RUNE_ConjureFamiliarRightFX, false)
						RightFXSpell = po3_RUNE_ConjureFamiliarRightFX
					elseif RightSpellType == 28
						PlayerRef.AddSpell(po3_RUNE_ReanimateRightFX, false)
						RightFXSpell = po3_RUNE_ReanimateRightFX				
					elseif RightSpellType == 29
						PlayerRef.AddSpell(po3_RUNE_SoulTrapRightFX, false)
						RightFXSpell = po3_RUNE_SoulTrapRightFX
					elseif RightSpellType == 30
						PlayerRef.AddSpell(po3_RUNE_ConjurationRightFX, false)
						RightFXSpell = po3_RUNE_ConjurationRightFX
					elseif RightSpellType == 31
						PlayerRef.AddSpell(po3_RUNE_MysticHealRightFX, false)
						RightFXSpell = po3_RUNE_MysticHealRightFX
					elseif RightSpellType == 32
						PlayerRef.AddSpell(po3_RUNE_AvatarRightFX, false)
						RightFXSpell = po3_RUNE_AvatarRightFX
					elseif RightSpellType == 34
						PlayerRef.AddSpell(po3_RUNE_BanishRightFX, false)
						RightFXSpell = po3_RUNE_BanishRightFX
					endif
				endif
			endif
		endif
		;---------------------------------------------------------------
		If asEventName == "MRh_SpellFire_Event" ; right spell fired
			If RightSpell 
				MagicEffect effect = RightSpell.GetNthEffectMagicEffect(0)			
				If effect.GetCastingType() ==  1 
					PlayerRef.RemoveSpell(RightFXSpell)
					RightFXSpell = None
				endif
			elseif RightScroll	
				PlayerRef.RemoveSpell(RightFXSpell)	
				RightFXSpell = None
			endif
		endif
		;---------------------------------------------------------------
		If asEventName == "MLh_SpellFire_Event" ; left spell fired
			If  PlayerRef.GetAnimationVariableBool("IsCastingDual") 
				PlayerRef.RemoveSpell(RightFXSpell)
				PlayerRef.RemoveSpell(LeftFXSpell)
				RightFXSpell = None
				LeftFXSpell = None
			endif
			If LeftSpell
				MagicEffect effect = LeftSpell.GetNthEffectMagicEffect(0)			
				If effect.GetCastingType() ==  1
					Utility.Wait(0.1)
					PlayerRef.RemoveSpell(LeftFXSpell)	
					LeftFXSpell = None
				endif
			elseif LeftScroll		
				PlayerRef.RemoveSpell(LeftFXSpell)	
				LeftFXSpell = None
			endif
		endif
		;----------------------------------------------------------------	
		If asEventName == "CastStop" ; only if caster has enough magic
			If LeftWard 
				PlayerRef.RemoveSpell(LeftFXSpell)
				LeftFXSpell = None	
				LeftWard = None
			endif
			If RightWard
				PlayerRef.RemoveSpell(RightFXSpell)
				RightFXSpell = None
				RightWard = None
			endif
			If PlayerRef.GetActorValuePercentage("Magicka") <= 0.01
				PlayerRef.RemoveSpell(LeftFXSpell)
				PlayerRef.RemoveSpell(RightFXSpell)
				LeftFXSpell = None			
				RightFXSpell = None
			endif
		endif
		;----------------------------------------------------------------
		If asEventName == "weaponSheathe" ; spell cancelled
			If LeftFXSpell || RightFXSpell
				PlayerRef.RemoveSpell(LeftFXSpell)
				PlayerRef.RemoveSpell(RightFXSpell)
				LeftFXSpell = None			
				RightFXSpell = None
				RightWard = None
				LeftWard = None
			endif
		endif
		
	endif
	
EndEvent 

;------------------ EVENT ONOBJECTUNEQUIPPED() ---------------------------------------- 

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)

	If (akBaseObject as Spell) 
	
		If (akBaseObject as Spell) == LeftSpell 
			PlayerRef.RemoveSpell(LeftFXSpell)
			LeftFXSpell = None
			LeftWard = None
		endif
		If(akBaseObject as Spell) == RightSpell 
			PlayerRef.RemoveSpell(RightFXSpell)
			RightFXSpell = None
			RightWard = None
		endif
		
	elseif (akBaseObject as Scroll)
	
		If (akBaseObject as Scroll) == LeftScroll 
			PlayerRef.RemoveSpell(LeftFXSpell)
			LeftFXSpell = None
		endif
		If(akBaseObject as Scroll) == RightScroll 
			PlayerRef.RemoveSpell(RightFXSpell)
			RightFXSpell = None
		endif	
		
	endif
	
EndEvent

;--------------------------------------------------------------------

Event OnEffectFinish(Actor akTarget, Actor akCaster)

	PlayerRef.RemoveSpell(LeftFXSpell)
	PlayerRef.RemoveSpell(RightFXSpell)
	LeftFXSpell = None			
	RightFXSpell = None
		
EndEvent

;======================================================================================;
;  FUNCTIONS  /
;=============/

Int Function GetTypeOfRune(Spell kSpell)

	MagicEffect effect = kSpell.GetNthEffectMagicEffect(0)
	
	If effect.GetAssociatedSkill() == "Destruction"			;(1-7)
		;destruction
		If !effect.HasKeyword(MagicRune)
			If effect.HasKeyword(MagicDamageFire) || effect.GetLight() == MagicLightFireInHand;fire
				return 1
			elseif effect.HasKeyword(MagicDamageFrost) || effect.GetLight() == MagicLightFrostHand01 ;frost
				return 2
			elseif effect.HasKeyword(MagicDamageShock) || effect.GetLight() == MagicLightShockInHand ;shock
				return 3
			elseif effect.HasKeyword(MagicVampireDrain)
				return 4
			elseif effect.HasKeywordString("MagicDamageDeath") || effect.HasKeywordString("xkLichCurse") 
				return 28
			elseif effect.HasKeywordString("MagicDamageNature")
				return 11
			else
				return 32 ; generic destruction
			endif
		else
			If effect.HasKeyword(MagicDamageFire) ;fire
				return 5
			elseif effect.HasKeyword(MagicDamageFrost) ;frost
				return 6
			elseif effect.HasKeyword(MagicDamageShock) ;shock
				return 7
			else
				return 5 ; generic fire rune
			endif
		endif
	elseif effect.GetAssociatedSkill() == "Restoration"		;(8-11, 20)
		;restoration
		If effect.GetHitShader() == DLC1SunFireImpactFXShader || effect.GetHitShader() == DLC1SunFireFXShader || effect.GetCastingArt() == DLC1_SunCloakSpellHandFX ;sun 
			return 8						
		elseif effect.HasKeyword(MagicTurnUndead) ||  effect.HasKeywordString("WB_Restoration_Keyword_IsAntiUndeadSpell")
			return 28
		elseif effect.HasKeyword(MagicRestoreHealth) || effect.GetCastingArt()== Heal01HandEffects  ;healing
			return 9
		elseif effect.HasKeyword(MagicWard)
			return 33 ; art implemented - v2.0
		elseif effect.HasKeywordString("WB_Restoration_Keyword_Damage") || effect.HasKeywordString("WB_Restoration_Keyword_IsInstakillSpell") || effect.HasKeywordString("WB_Restoration_Keyword_IsTapSpell")
			return 4
		elseif effect.GetCastingArt()== HealsMystFXHand01 || effect.HasKeywordString("WB_Restoration_Keyword_IsRestoreManaSpell") || effect.HasKeywordString("WB_Buff")  ;mystic heals
			return 31
		elseif kSpell.GetName() == "Poison Rune" ;poison rune
			return 10
		elseif effect.IsEffectFlagSet(0x00000004) || effect.HasKeywordString("WB_Restoration_Keyword_LeechSeed_Health") || effect.HasKeywordString("WB_Restoration_Keyword_Necroplague") ;poison or damaging restoration
			return 11
		else
			return 9 ; generic heal
		endif
	elseif effect.GetAssociatedSkill() == "Alteration"		;(12-11, 4)
		;alteration
		If effect.HasKeyword(MagicParalysis)
			If effect.HasKeyword(MagicRune) 
				return 12 ;ash rune
			else
				return 13 ;normal paralysis
			endif
		elseif effect.GetLight() == MagicLightFrostHand01
			return 2
		elseif GetEffectArchetypeAsString(effect) == "DetectLife" || effect.GetCastingArt() == DetectLifeFXHand01 ;detect life or whatever
			return 15
		elseif effect.HasKeyword(MagicTelekinesis) || effect.HasKeywordString("WB_Alteration_Orb")
			return 17
		elseif effect.HasKeyword(MagicArmorSpell) || effect.HasKeywordString("WB_Buff") ;armour spells
			return 14
		elseif GetEffectArchetypeAsString(effect) == "Light" || effect.GetCastingArt() == FXLightSpellHandEffects ;light spells
			return 16
		else
			return 18 ; generic alt
		endif
	elseif effect.GetAssociatedSkill() == "Illusion"		;(19-14)
		;illusion
		If effect.HasKeyword(MagicRune) && effect.HasKeyword(MagicInfluenceFrenzy)
			return 19
		elseif effect.HasKeywordString("kDoppelganger")
			return 1
		elseif GetEffectArchetypeAsString(effect) == "Frenzy" || GetEffectArchetypeAsString(effect) == "Demoralize" || effect.GetCastingArt() == IllusionNegFXHand01 ;fear, frenzy
			return 20
		elseif GetEffectArchetypeAsString(effect) == "Calm" || effect.GetCastingArt() == IllusionPosFXHand01  ;calm, charm
			return 21
		elseif effect.HasKeyword(MagicInvisibility) || effect.HasKeywordString("MagicDamageArcane")  || effect.HasKeywordString("WB_Illusion_Keyword_Phantom_Ab") || effect.HasKeywordString("WB_Illusion_Keyword_EvilTwin")
			return 22
		elseif effect.HasKeywordString("WB_Illusion_Keyword_Damage") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterDuration") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterInstant")
			return 29
		else
			return 23 ;generic illusion
		endif
	elseif effect.GetAssociatedSkill() == "Conjuration"		;(22-16)
		;conjuration
		If effect.HasKeyword(MagicSummonFire) || effect.HasKeywordString("WB_Conjuration_Detonate") || effect.HasKeyword(DLC2MagicAshSpawn) ;fire
			return 24
		elseif effect.HasKeyword(MagicSummonFrost) ;frost
			return 25
		elseif effect.HasKeyword(MagicSummonShock) ;shock
			return 26
		elseif effect.HasKeyword(MagicSummonFamiliar) 
			return 27
		elseif effect.HasKeyword(MagicSummonUndead)
			return 28
		elseif GetEffectArchetypeAsString(effect) == "Banish"
			return 34
		elseif effect.GetCastingArt()== SoulTrapHandEffects 
			return 29
		elseif effect.HasKeyword(MagicRestoreHealth)
			return 9
		else
			return 30 ; generic conjuration 
		endif
	else
		;none
		if effect.HasKeyword(MagicVampireDrain) || effect.HasKeyword(DLC1VampireDrainEffect)
			return 4 ; vampire drain
		elseif effect.GetLight() == MagicLightTelekinesisHand01
			return 17
		endif
	endif		

	return -1	
	
EndFunction

;--------------------------------------------------------------------------------------------------

Int Function GetTypeOfRuneScroll(Scroll kScroll)

	MagicEffect effect = kScroll.GetNthEffectMagicEffect(0)
	
	If effect.GetAssociatedSkill() == "Destruction"			;(1-7)
		;destruction
		If effect.HasKeyword(MagicDamageFire) || effect.GetLight() == MagicLightFireInHand;fire
			return 1
		elseif effect.HasKeyword(MagicDamageFrost) || effect.GetLight() == MagicLightFrostHand01 ;frost
			return 2
		elseif effect.HasKeyword(MagicDamageShock) || effect.GetLight() == MagicLightShockInHand ;shock
			return 3
		elseif effect.HasKeyword(MagicVampireDrain)
			return 4
		elseif effect.HasKeywordString("MagicDamageDeath") || effect.HasKeywordString("xkLichCurse") 
			return 28
		elseif effect.HasKeywordString("MagicDamageNature")
			return 11
		else
			return 32 ; generic destruction
		endif
	elseif effect.GetAssociatedSkill() == "Restoration"		;(8-11, 20)
		;restoration
		If effect.GetHitShader() == DLC1SunFireImpactFXShader || effect.GetHitShader() == DLC1SunFireFXShader || effect.GetCastingArt() == DLC1_SunCloakSpellHandFX ;sun 
			return 8						
		elseif effect.HasKeyword(MagicTurnUndead) ||  effect.HasKeywordString("WB_Restoration_Keyword_IsAntiUndeadSpell")
			return 28
		elseif effect.HasKeyword(MagicRestoreHealth) || effect.GetCastingArt()== Heal01HandEffects  ;healing
			return 9
		elseif effect.HasKeywordString("WB_Restoration_Keyword_Damage") || effect.HasKeywordString("WB_Restoration_Keyword_IsInstakillSpell") || effect.HasKeywordString("WB_Restoration_Keyword_IsTapSpell")
			return 4
		elseif effect.GetCastingArt()== HealsMystFXHand01 || effect.HasKeywordString("WB_Restoration_Keyword_IsRestoreManaSpell") || effect.HasKeywordString("WB_Buff")  ;mystic heals
			return 31
		elseif effect.IsEffectFlagSet(0x00000004) || effect.HasKeywordString("WB_Restoration_Keyword_LeechSeed_Health") || effect.HasKeywordString("WB_Restoration_Keyword_Necroplague") ;poison or damaging restoration
			return 11
		else
			return 9 ; generic heal
		endif
	elseif effect.GetAssociatedSkill() == "Alteration"		;(12-11, 4)
		;alteration
		If effect.HasKeyword(MagicParalysis)
			return 13 ;normal paralysis
		elseif effect.GetLight() == MagicLightFrostHand01
			return 2
		elseif GetEffectArchetypeAsString(effect) == "DetectLife" || effect.GetCastingArt() == DetectLifeFXHand01 ;detect life or whatever
			return 15
		elseif effect.HasKeyword(MagicTelekinesis) || effect.HasKeywordString("WB_Alteration_Orb")
			return 17
		elseif effect.HasKeyword(MagicArmorSpell) || effect.HasKeywordString("WB_Buff") ;armour spells
			return 14
		elseif effect.GetCastingArt() == FXLightSpellHandEffects ;light spells
			return 16
		else
			return 18 ; generic alt
		endif
	elseif effect.GetAssociatedSkill() == "Illusion"		;(19-14)
		;illusion
		If effect.HasKeyword(MagicRune) && effect.HasKeyword(MagicInfluenceFrenzy)
			return 19
		elseif effect.HasKeywordString("kDoppelganger")
			return 1
		elseif GetEffectArchetypeAsString(effect) == "Frenzy" || GetEffectArchetypeAsString(effect) == "Demoralize" || effect.GetCastingArt() == IllusionNegFXHand01 ;fear, frenzy
			return 20
		elseif GetEffectArchetypeAsString(effect) == "Calm" || effect.GetCastingArt() == IllusionPosFXHand01  ;calm, charm
			return 21
		elseif effect.HasKeyword(MagicInvisibility) || effect.HasKeywordString("MagicDamageArcane")  || effect.HasKeywordString("WB_Illusion_Keyword_Phantom_Ab") || effect.HasKeywordString("WB_Illusion_Keyword_EvilTwin")
			return 22
		elseif effect.HasKeywordString("WB_Illusion_Keyword_Damage") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterDuration") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterInstant")
			return 29
		else
			return 23 ;generic illusion
		endif
	elseif effect.GetAssociatedSkill() == "Conjuration"		;(22-16)
		;conjuration
		If effect.HasKeyword(MagicSummonFire) || effect.HasKeywordString("WB_Conjuration_Detonate") || effect.HasKeyword(DLC2MagicAshSpawn) ;fire
			return 24
		elseif effect.HasKeyword(MagicSummonFrost) ;frost
			return 25
		elseif effect.HasKeyword(MagicSummonShock) ;shock
			return 26
		elseif effect.HasKeyword(MagicSummonFamiliar) 
			return 27
		elseif effect.HasKeyword(MagicSummonUndead)
			return 28
		elseif GetEffectArchetypeAsString(effect) == "Banish"
			return 34
		elseif effect.GetCastingArt()== SoulTrapHandEffects 
			return 29
		elseif effect.HasKeyword(MagicRestoreHealth)
			return 9
		else
			return 30 ; generic conjuration 
		endif
	else
		;none
		if effect.HasKeyword(MagicVampireDrain) || effect.HasKeyword(DLC1VampireDrainEffect)
			return 4 ; vampire drain
		elseif effect.GetLight() == MagicLightTelekinesisHand01
			return 17
		endif
	endif		

	return -1	
	
EndFunction

;=================================================================================================

Int Function GetTypeOfRitualRune(Spell kSpell)

	MagicEffect effect = kSpell.GetNthEffectMagicEffect(0)
	MagicEffect effect2 = kSpell.GetNthEffectMagicEffect(1)
	
	If effect.GetAssociatedSkill() == "Destruction"			;(1-7)
		;destruction
		If effect.HasKeyword(MagicDamageFire) || effect.GetLight() == MagicLightFireInHand;fire
			return 1
		elseif effect.HasKeyword(MagicDamageFrost) || effect.GetLight() == MagicLightFrostHand01 ;frost
			return 2
		elseif effect.HasKeyword(MagicDamageShock) || effect.GetLight() == MagicLightShockInHand ;shock
			return 3
		elseif effect.HasKeyword(MagicVampireDrain)
			return 4
		elseif effect.HasKeywordString("MagicDamageDeath") || effect.HasKeywordString("xkLichCurse") 
			return 28
		elseif effect.HasKeywordString("MagicDamageNature")
			return 11
		else
			return 32 ; generic destruction
		endif
	elseif effect.GetAssociatedSkill() == "Restoration"		;(8-11, 20)
		;restoration
		If effect.GetHitShader() == DLC1SunFireImpactFXShader || effect.GetHitShader() == DLC1SunFireFXShader || effect.GetCastingArt() == DLC1_SunCloakSpellHandFX ;sun 
			return 8						
		elseif effect.HasKeyword(MagicTurnUndead) || effect2 && effect2.HasKeyword(MagicTurnUndead) || effect.HasKeywordString("WB_Restoration_Keyword_IsAntiUndeadSpell")
			return 28
		elseif effect.HasKeyword(MagicRestoreHealth) || effect.GetCastingArt()== Heal01HandEffects  ;healing
			return 9
		elseif effect.HasKeywordString("WB_Restoration_Keyword_Damage") || effect.HasKeywordString("WB_Restoration_Keyword_IsInstakillSpell") || effect.HasKeywordString("WB_Restoration_Keyword_IsTapSpell")
			return 4
		elseif effect.GetCastingArt()== HealsMystFXHand01 || effect.HasKeywordString("WB_Restoration_Keyword_IsRestoreManaSpell") || effect.HasKeywordString("WB_Buff")  ;mystic heals
			return 31
		elseif effect.IsEffectFlagSet(0x00000004) || effect.HasKeywordString("WB_Restoration_Keyword_LeechSeed_Health") || effect.HasKeywordString("WB_Restoration_Keyword_Necroplague") ;poison or damaging restoration
			return 11
		;----------added for Wards Functionalities Extended patch----------
		elseif effect.HasKeyword(MagicWard) 
			return 0
		;--------------------------------------------------------------------
		else
			return 9 ; generic heal
		endif
	elseif effect.GetAssociatedSkill() == "Alteration"		;(12-11, 4)
		;alteration
		If effect.HasKeyword(MagicParalysis)
			return 13 ;normal paralysis
		elseif effect.GetLight() == MagicLightFrostHand01
			return 2
		elseif GetEffectArchetypeAsString(effect) == "DetectLife" || effect.GetCastingArt() == DetectLifeFXHand01 ;detect life or whatever
			return 15
		elseif effect.HasKeyword(MagicTelekinesis) || effect.HasKeywordString("WB_Alteration_Orb")
			return 17
		elseif effect.HasKeyword(MagicArmorSpell) || effect.HasKeywordString("WB_Buff") ;armour spells
			return 14
		elseif GetEffectArchetypeAsString(effect) == "Light" || effect.GetCastingArt() == FXLightSpellHandEffects ;light spells
			return 16
		else
			return 18 ; generic alt
		endif
	elseif effect.GetAssociatedSkill() == "Illusion"		;(19-14)
		;illusion
		If effect.HasKeywordString("kDoppelganger")
			return 1
		elseif GetEffectArchetypeAsString(effect) == "Frenzy" || GetEffectArchetypeAsString(effect) == "Demoralize" || effect.GetCastingArt() == IllusionNegFXHand01 ;fear, frenzy
			return 20
		elseif GetEffectArchetypeAsString(effect) == "Calm" || effect.GetCastingArt() == IllusionPosFXHand01  ;calm, charm
			return 21
		elseif effect.HasKeyword(MagicInvisibility) || effect.HasKeywordString("MagicDamageArcane")  || effect.HasKeywordString("WB_Illusion_Keyword_Phantom_Ab") || effect.HasKeywordString("WB_Illusion_Keyword_EvilTwin")
			return 29
		elseif effect.HasKeywordString("WB_Illusion_Keyword_Damage") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterDuration") || effect.HasKeywordString("WB_Illusion_Keyword_AnticasterInstant")
			return 29
		else
			return 23 ;generic illusion
		endif
	elseif effect.GetAssociatedSkill() == "Conjuration"		;(22-16)
		;conjuration
		If effect.HasKeyword(MagicSummonFire) || effect.HasKeywordString("WB_Conjuration_Detonate") || effect.HasKeyword(DLC2MagicAshSpawn) ;fire
			return 24
		elseif effect.HasKeyword(MagicSummonFrost) ;frost
			return 25
		elseif effect.HasKeyword(MagicSummonShock) ;shock
			return 26
		elseif effect.HasKeyword(MagicSummonFamiliar) 
			return 27
		elseif effect.HasKeyword(MagicSummonUndead)
			return 28
		elseif effect.GetCastingArt()== SoulTrapHandEffects 
			return 29
		elseif effect.HasKeyword(MagicRestoreHealth)
			return 9
		else
			return 30 ; generic conjuration 
		endif
	endif		

	return -1	
	
EndFunction

;================================================================================================================================

Bool Function CanCastSpellType(Spell akSpell)

	MagicEffect effect = akSpell.GetNthEffectMagicEffect(0)
	int CastingType = effect.GetCastingType()
	
	If CastingType ==  1
	
		If po3_RUNE_AllowPCFFSpells.GetValue() == 1
		
			return true
		
		endif
		
		return false
	
	elseif CastingType ==  2
	
		If po3_RUNE_AllowPCConcSpells.GetValue() == 1
		
			return true
		
		endif
		
		return false

	endif
	
endFunction

;-----------------------------------------------------------------------------------------------------

Bool Function CanCastScrollType(Scroll akSpell)

	If po3_RUNE_AllowPCScrolls.GetValue() == 1
		
		return true
		
	endif 
		
	return false
			
endFunction

;--------------------------------------------------------------------------------------------------------------------

Spell Function MagicCircle(Spell HandSpell, Spell NormSpell, Spell ConcSpell)

	Spell FXSpell

	If po3_RUNE_AllowMagAnimPatch.GetValue() ==  1.0
	
		MagicEffect effect = HandSpell.GetNthEffectMagicEffect(0)
		
		If effect.GetCastingType() ==  2 && effect.GetDeliveryType() ==  0
			
			PlayerRef.AddSpell(ConcSpell, false)
			FXSpell = ConcSpell
			return FXSpell
			
		else
		
			PlayerRef.AddSpell(NormSpell, false)
			FXSpell = NormSpell
			return FXSpell
			
		endif
		
	else
	
		PlayerRef.AddSpell(NormSpell, false)
		FXSpell = NormSpell
		return FXSpell
			
	endif

EndFunction	
